//######################
//## Global Variables ##
var RefreshRate = 1000;
//######################

function GetTagsList()
{
	//Get the list of Tags using Export Block Descriptor $dtTL$ftT
	jQuery.ajax ( { url:"../rcgi.bin/ParamForm?AST_Param=$$dtTL$ftT", dataType:"text", success:TagsListReceived, error:TagsListError, timeout:20000 });
	
}


function TagsListReceived(tagslist)
{
	//When the list of tags is received, parse it, create the HTML Table and read the values for the first time
	var Data = new Array();
	Data = CSVToArray(tagslist,";");
	
	for (var i=1;i<Data.length - 1;i++)
	{
		var TagName = Data[i][1];
		var Comment = Data[i][2];
		if (Comment == undefined) Comment = "";	
		
		$('#tagstable').append('<tr><td>' + TagName + 
		'</td><td id="' + TagName + '">-</td><td>' +
		Comment + '</td></tr>');
	}
	
	GetTagValues();
} 

function TagsListError()
{
	setTimeout("GetTagsList()", 1000);
}


function GetTagValues()
{
	//Get the Tags values using Export Block Descriptor $dtIV$ftT
	jQuery.ajax ( { url:"../rcgi.bin/ParamForm?AST_Param=$$dtIV$ftT", dataType:"text", success:TagValuesReceived, error:TagValuesError, timeout:10000 });
	//rcgi.bin/ParamForm?AST_Param=$$dtSE$se"TIME$"$ftT
	jQuery.ajax ( { url:"../rcgi.bin/ParamForm?AST_Param=$$dtSE$se\"TIME$\"$ftT", dataType:"text", success:TimeReceived, error:TagsListError, timeout:5000 });

}

function TimeReceived(time)
{
	$('#eWONtime').html(time);
}

function TagValuesReceived(tagvalues)
{
	//When the tag values are received, parse the file, update the HTML Table and re-try in 1 sec
	var Data = new Array();
	Data = CSVToArray(tagvalues,";");
	
	
	for (var i=1;i<Data.length - 1;i++)
	{
		$('#' + Data[i][1]).html(Data[i][2].toString());
	}
	$('#commstatusnok').hide();
	$('#commstatusok').show();	
	
	setTimeout("GetTagValues()", RefreshRate);
} 

function TagValuesError()
{
	$('#commstatusok').hide();
	$('#commstatusnok').show();
	setTimeout("GetTagValues()", 1000);
}


function CSVToArray( strData, strDelimiter )
{
//###################################################################################
//function used to parsed the CSV files received by eWON : Tags List and Tag values##
//###################################################################################

    	// Check to see if the delimiter is defined. If not,
    	// then default to comma.
    	strDelimiter = (strDelimiter || ",");

    	// Create a regular expression to parse the CSV values.
    	var objPattern = new RegExp(
    		(
    			// Delimiters.
    			"(\\" + strDelimiter + "|\\r?\\n|\\r|^)" +

    			// Quoted fields.
    			"(?:\"([^\"]*(?:\"\"[^\"]*)*)\"|" +

    			// Standard fields.
    			"([^\"\\" + strDelimiter + "\\r\\n]*))"
    		),
    		"gi"
    		);


    	// Create an array to hold our data. Give the array
    	// a default empty first row.
    	var arrData = [[]];

    	// Create an array to hold our individual pattern
    	// matching groups.
    	var arrMatches = null;


    	// Keep looping over the regular expression matches
    	// until we can no longer find a match.
    	while (arrMatches = objPattern.exec( strData )){

    		// Get the delimiter that was found.
    		var strMatchedDelimiter = arrMatches[ 1 ];

    		// Check to see if the given delimiter has a length
    		// (is not the start of string) and if it matches
    		// field delimiter. If id does not, then we know
    		// that this delimiter is a row delimiter.
    		if (
    			strMatchedDelimiter.length &&
    			(strMatchedDelimiter != strDelimiter)
    			){

    			// Since we have reached a new row of data,
    			// add an empty row to our data array.
    			arrData.push( [] );

    		}


    		// Now that we have our delimiter out of the way,
    		// let's check to see which kind of value we
    		// captured (quoted or unquoted).
    		if (arrMatches[ 2 ]){

    			// We found a quoted value. When we capture
    			// this value, unescape any double quotes.
    			var strMatchedValue = arrMatches[ 2 ].replace(
    				new RegExp( "\"\"", "g" ),
    				"\""
    				);

    		} else {

    			// We found a non-quoted value.
    			var strMatchedValue = arrMatches[ 3 ];

    		}

    		// Now that we have our value string, let's add
    		// it to the data array.
    		arrData[ arrData.length - 1 ].push( strMatchedValue );
    	}

    // Return the parsed data.
    return( arrData );
}


//starts the process - first function called at page loading
GetTagsList();